import { __decorate } from "tslib";
import { transient } from 'mana-syringe';
var counter = 0;

var Component =
/** @class */
function () {
  function Component() {
    // eslint-disable-next-line no-plusplus
    this.pid = counter++;
  }

  Component_1 = Component;

  Component.prototype.getId = function () {
    return this.pid;
  };

  Component.prototype.copy = function (props) {
    Object.assign(this, props);
    return this;
  };

  Component.prototype.clone = function () {
    return new Component_1().copy(this);
  };

  Component.prototype.reset = function () {//
  };

  Component.prototype.destroy = function () {//
  };

  var Component_1;
  Component = Component_1 = __decorate([transient()], Component);
  return Component;
}();

export { Component };