import { __decorate, __metadata } from "tslib";
import { inject, singleton } from 'mana-syringe';
import { IDENTIFIER } from './identifier';

var ComponentManager =
/** @class */
function () {
  function ComponentManager() {}

  ComponentManager.prototype.registerComponent = function (clazz) {
    this.registry(clazz);
  };

  __decorate([inject(IDENTIFIER.ComponentRegistry), __metadata("design:type", Function)], ComponentManager.prototype, "registry", void 0);

  ComponentManager = __decorate([singleton()], ComponentManager);
  return ComponentManager;
}();

export { ComponentManager };