"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Component = void 0;

var _tslib = require("tslib");

var _manaSyringe = require("mana-syringe");

var counter = 0;

var Component =
/** @class */
function () {
  function Component() {
    // eslint-disable-next-line no-plusplus
    this.pid = counter++;
  }

  Component_1 = Component;

  Component.prototype.getId = function () {
    return this.pid;
  };

  Component.prototype.copy = function (props) {
    Object.assign(this, props);
    return this;
  };

  Component.prototype.clone = function () {
    return new Component_1().copy(this);
  };

  Component.prototype.reset = function () {//
  };

  Component.prototype.destroy = function () {//
  };

  var Component_1;
  Component = Component_1 = (0, _tslib.__decorate)([(0, _manaSyringe.transient)()], Component);
  return Component;
}();

exports.Component = Component;